<!doctype html>
<html
	xmlns:th="http://www.thymeleaf.org"
	xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
	layout:decorate="~{layouts/app.html}"
>
	<head>
		<!-- Primary Meta Tags -->
		<meta name="title" content="Inbox" />
		<!-- tinymce -->
		<script src="/tinymce/tinymce.min.js" referrerpolicy="origin"></script>
		<style>
			.tox.tox-tinymce {
				border-radius: var(--default-border-radius);
				border: 1px solid hsl(var(--surface-outline));
			}
		</style>
		<title layout:title-pattern="$CONTENT_TITLE - $LAYOUT_TITLE" th:text="${title}">Buat Berita</title>
	</head>
	<body layout:fragment="content">
		<div class="px-5" id="editor">
			<form method="post" th:object="${news}" th:action="@{/news/create-news}" novalidate>
				<input type="hidden" name="id" th:field="*{id}" />
				<div class="flex flex-col gap-4 lg:flex-row">
					<div
						th:x-data="'{ title : \'' + (${news.title == null ? '' : news.title}) + '\', slug : \'' + (${news.slug == null ? '' : news.slug}) + '\', generateSlug(){this.slug = this.title.toLowerCase().trim().replace(/\s+/g, \'-\').replace(/[^\w\-]+/g, \'\').replace(/--+/g, \'-\').replace(/^-+/, \'\').replace(/-+$/, \'\')}}'"
						class="basis-full rounded-default bg-surface-container p-4 lg:basis-8/12"
					>
						<!-- title -->
						<div>
							<div class="relative">
								<input
									x-model="title"
									@input="generateSlug"
									class="needs-validation block w-full rounded-default border border-surface-outline bg-transparent px-4 py-3 ps-11 text-sm text-on-surface focus:border-primary-outline-highest focus:ring-primary-outline-highest data-[invalid=true]:border-error-outline data-[invalid=true]:ring-error-outline-highest data-[invalid=true]:focus:border-error-outline-highest"
									type="text"
									id="title"
									name="title"
									placeholder="Judul Berita"
									value=""
									required="required"
									autofocus="autofocus"
								/>
								<div class="absolute inset-y-0 start-0 flex items-center ps-4">
									<svg
										xmlns="http://www.w3.org/2000/svg"
										fill="none"
										viewBox="0 0 24 24"
										stroke-width="1.5"
										stroke="currentColor"
										class="size-4 shrink-0 text-on-surface-lower"
									>
										<path
											stroke-linecap="round"
											stroke-linejoin="round"
											d="M12 7.5h1.5m-1.5 3h1.5m-7.5 3h7.5m-7.5 3h7.5m3-9h3.375c.621 0 1.125.504 1.125 1.125V18a2.25 2.25 0 0 1-2.25 2.25M16.5 7.5V18a2.25 2.25 0 0 0 2.25 2.25M16.5 7.5V4.875c0-.621-.504-1.125-1.125-1.125H4.125C3.504 3.75 3 4.254 3 4.875V18a2.25 2.25 0 0 0 2.25 2.25h13.5M6 7.5h3v3H6v-3Z"
										></path>
									</svg>
								</div>
							</div>
							<p id="errortitle" class="mt-2 block text-sm text-error"></p>
						</div>
						<!-- slug -->
						<div x-data="{editing : false }" class="mb-4">
							<div
								x-data="{baseUrl : window.location.origin}"
								class="flex w-full items-center text-sm italic text-on-surface-lower"
							>
								<p>slug :</p>
								<p x-text="baseUrl">baseUrl</p>
								<p>/</p>
								<input
									class="truncate bg-transparent text-sm"
									:class="editing ?'p-1 ms-1 flex-1':'p-0 border-none text-on-surface-lower'"
									:disabled="editing ? false : true"
									type="text"
									id="slug"
									name="slug"
									x-model="slug"
									required="required"
									autofocus="autofocus"
								/>
								<button
									@click="editing = !editing"
									type="button"
									class="ms-1 inline-flex text-primary"
									:class="slug != '' ? 'block':'hidden'"
								>
									<svg
										xmlns="http://www.w3.org/2000/svg"
										fill="none"
										viewBox="0 0 24 24"
										stroke-width="1.5"
										stroke="currentColor"
										class="size-3.5"
										:class="editing ? 'hidden':'block'"
									>
										<path
											stroke-linecap="round"
											stroke-linejoin="round"
											d="m16.862 4.487 1.687-1.688a1.875 1.875 0 1 1 2.652 2.652L6.832 19.82a4.5 4.5 0 0 1-1.897 1.13l-2.685.8.8-2.685a4.5 4.5 0 0 1 1.13-1.897L16.863 4.487Zm0 0L19.5 7.125"
										/>
									</svg>
									<svg
										xmlns="http://www.w3.org/2000/svg"
										fill="none"
										viewBox="0 0 24 24"
										stroke-width="1.5"
										stroke="currentColor"
										class="size-4 stroke-success"
										:class="editing ? 'block':'hidden'"
									>
										<path
											stroke-linecap="round"
											stroke-linejoin="round"
											d="m4.5 12.75 6 6 9-13.5"
										/>
									</svg>
								</button>
							</div>
						</div>
						<!-- text editor -->
						<div class="relative">
							<textarea
								id="content"
								rows="6"
								name="content"
								th:field="*{content}"
								class="block w-full rounded-default border border-surface-outline bg-transparent px-4 py-3 text-sm text-on-surface focus:border-primary-outline-highest focus:ring-primary-outline-highest data-[invalid=true]:border-error-outline data-[invalid=true]:ring-error-outline-highest data-[invalid=true]:focus:border-error-outline-highest"
								placeholder="Tulis Content Berita disni..."
							></textarea>
						</div>
					</div>
					<div class="basis-full space-y-4 rounded-default bg-surface-container p-4 lg:basis-4/12">
						<div>
							<div class="relative">
								<input
									class="needs-validation block w-full rounded-default border border-surface-outline bg-transparent px-4 py-3 ps-11 text-sm text-on-surface focus:border-primary-outline-highest focus:ring-primary-outline-highest data-[invalid=true]:border-error-outline data-[invalid=true]:ring-error-outline-highest data-[invalid=true]:focus:border-error-outline-highest"
									type="text"
									id="author"
									name="author"
									th:field="*{author}"
									placeholder="Author"
									value=""
									required="required"
									autofocus="autofocus"
								/>
								<div class="absolute inset-y-0 start-0 flex items-center ps-4">
									<svg
										xmlns="http://www.w3.org/2000/svg"
										fill="none"
										viewBox="0 0 24 24"
										stroke-width="1.5"
										stroke="currentColor"
										class="size-4 shrink-0 text-on-surface-lower"
									>
										<path
											stroke-linecap="round"
											stroke-linejoin="round"
											d="M15.75 6a3.75 3.75 0 1 1-7.5 0 3.75 3.75 0 0 1 7.5 0ZM4.501 20.118a7.5 7.5 0 0 1 14.998 0A17.933 17.933 0 0 1 12 21.75c-2.676 0-5.216-.584-7.499-1.632Z"
										/>
									</svg>
								</div>
							</div>
							<p id="errorauthor" class="mt-2 block text-sm text-error"></p>
						</div>

						<div>
							<div class="relative">
								<select
									class="needs-validation block w-full rounded-default border border-surface-outline bg-surface-container px-4 py-3 ps-11 text-sm text-on-surface focus:border-primary-outline-highest focus:ring-primary-outline-highest data-[invalid=true]:border-error-outline data-[invalid=true]:ring-error-outline-highest data-[invalid=true]:focus:border-error-outline-highest"
									name="status"
									th:field="*{status}"
									required
								>
									<option value="">Status</option>
									<option th:each="status : ${newsStatus}" th:text="${status}" th:value="${status}">
										Draft
									</option>
								</select>
								<div class="absolute inset-y-0 start-0 flex items-center ps-4">
									<svg
										xmlns="http://www.w3.org/2000/svg"
										fill="none"
										viewBox="0 0 24 24"
										stroke-width="1.5"
										stroke="currentColor"
										class="size-4 shrink-0 text-on-surface-lower"
									>
										<path
											stroke-linecap="round"
											stroke-linejoin="round"
											d="M12 21a9.004 9.004 0 0 0 8.716-6.747M12 21a9.004 9.004 0 0 1-8.716-6.747M12 21c2.485 0 4.5-4.03 4.5-9S14.485 3 12 3m0 18c-2.485 0-4.5-4.03-4.5-9S9.515 3 12 3m0 0a8.997 8.997 0 0 1 7.843 4.582M12 3a8.997 8.997 0 0 0-7.843 4.582m15.686 0A11.953 11.953 0 0 1 12 10.5c-2.998 0-5.74-1.1-7.843-2.918m15.686 0A8.959 8.959 0 0 1 21 12c0 .778-.099 1.533-.284 2.253m0 0A17.919 17.919 0 0 1 12 16.5c-3.162 0-6.133-.815-8.716-2.247m0 0A9.015 9.015 0 0 1 3 12c0-1.605.42-3.113 1.157-4.418"
										/>
									</svg>
								</div>
							</div>
							<p id="errorstatus" class="mt-2 block text-sm text-error"></p>
						</div>
						<div>
							<div id="featuredBtn">
								<img
									id="selected-featured-img"
									class="h-64 w-full rounded-default object-cover"
									th:classappend="${news.thumbnail == null ? 'hidden' : ''}"
									th:src="${news.thumbnail == null ? '' : news.thumbnail}"
									alt="thubnail"
								/>
								<div
									id="dropzone"
									class="flex h-64 w-full flex-col items-center justify-center rounded-default border-2 border-dashed border-surface-outline-lower bg-surface-container hover:bg-surface-container-higher"
								>
									<div class="flex flex-col items-center justify-center pb-6 pt-5">
										<svg
											class="mb-4 h-8 w-8 text-on-surface-lower"
											aria-hidden="true"
											xmlns="http://www.w3.org/2000/svg"
											fill="none"
											viewBox="0 0 20 16"
										>
											<path
												stroke="currentColor"
												stroke-linecap="round"
												stroke-linejoin="round"
												stroke-width="2"
												d="M13 13h3a3 3 0 0 0 0-6h-.025A5.56 5.56 0 0 0 16 6.5 5.5 5.5 0 0 0 5.207 5.021C5.137 5.017 5.071 5 5 5a4 4 0 0 0 0 8h2.167M10 15V6m0 0L8 8m2-2 2 2"
											/>
										</svg>
										<p class="mb-2 text-sm font-semibold text-on-surface-lower">Select Thumbnail</p>
									</div>
								</div>
							</div>
							<!-- featured img input -->
							<input
								name="thumbnail"
								th:field="*{thumbnail}"
								id="featured-img"
								type="text"
								class="hidden"
							/>
						</div>

						<button
							type="submit"
							class="inline-flex w-full items-center justify-center gap-x-2 rounded-default bg-primary px-3 py-2.5 text-sm font-semibold text-on-primary hover:bg-primary-higher focus:bg-primary-higher focus:outline-none focus-visible:ring-2 focus-visible:ring-primary-outline-lower disabled:cursor-not-allowed disabled:bg-primary-lowest disabled:text-on-primary/50"
						>
							Save
						</button>
					</div>
				</div>
			</form>
		</div>
	</body>
</html>
<script src="https://code.jquery.com/jquery-1.9.1.min.js"></script>
<script>
	tinymce.init({
		selector: "textarea#content",
		plugins:
			"preview importcss searchreplace autolink autosave save directionality code visualblocks visualchars fullscreen image link file-manager media codesample table charmap pagebreak nonbreaking anchor insertdatetime advlist lists wordcount help charmap  emoticons",
		editimage_cors_hosts: ["picsum.photos"],
		ui: {
			useAutoToolbar: false,
		},
		menubar: "file edit view insert format tools table help",
		toolbar:
			"undo redo | blocks fontsize | bold italic underline strikethrough | align numlist bullist | link Image | table media | lineheight outdent indent| forecolor backcolor removeformat | charmap emoticons | code fullscreen preview | pagebreak anchor codesample | ltr rtl",
		Flmngr: {
			apiKey: "FLMNFLMN", // default free key
			urlFileManager: "https://asetcms.stmik.tazkia.ac.id/flmngr",
			urlFiles: "https://asetcms.stmik.tazkia.ac.id/files",
		},
		setup: (editor) => {
			editor.on("init", (event) => {
				editor.getFlmngr((Flmngr) => {
					attachOnClickListenerToButton(Flmngr);
				});
			});
		},
		promotion: false,
		statusbar: false,
		autosave_ask_before_unload: true,
		autosave_interval: "30s",
		autosave_prefix: "{path}{query}-{id}-",
		autosave_restore_when_empty: false,
		autosave_retention: "2m",
		image_advtab: true,
	});

	function attachOnClickListenerToButton(Flmngr) {
		let featuredImgBtn = document.getElementById("featuredBtn");

		// Add a listener for selecting files
		featuredImgBtn.addEventListener("click", () => {
			selectFiles(Flmngr);
		});
	}

	function selectFiles(Flmngr) {
		Flmngr.open({
			isMultiple: false,
			acceptExtensions: ["png", "jpeg", "jpg", "webp", "gif"],
			onFinish: (files) => {
				showSelectedImage(files);
			},
		});
	}

	function showSelectedImage(files) {
		let elImages = document.getElementById("selected-featured-img");
		let dropzone = document.getElementById("dropzone");
		let featuredImgInput = document.getElementById("featured-img");
		let file = files[0];
		elImages.src = file.url;
		featuredImgInput.value = file.url;
		dropzone.classList.add("hidden");
		elImages.classList.remove("hidden");
	}

	const featuredImg = document.getElementById("featured-img");
	const dropzone = document.getElementById("dropzone");

	if (featuredImg.value) {
		dropzone.classList.add("hidden");
	}
</script>
